<?xml version="1.0"?>
<!--
Copyright (C) 2009 Paul Boddie <paul@boddie.org.uk>

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the Free
Software Foundation; either version 3 of the License, or (at your option) any
later version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
details.

You should have received a copy of the GNU Lesser General Public License along
with this program.  If not, see <http://www.gnu.org/licenses/>.
-->
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:template="http://www.boddie.org.uk/ns/xmltools/template">

  <xsl:output indent="yes" method="xml"/>

  <!-- Process the root element. -->

  <xsl:template match="/">
    <translations>
      <locale>
        <xsl:apply-templates select="@*|node()"/>
      </locale>
    </translations>
  </xsl:template>



  <!-- Handle elements with translation attributes. -->

  <xsl:template match="*[@template:i18n]">
    <xsl:choose>
      <xsl:when test="@template:i18n = '-'">
        <translation>
          <xsl:attribute name="value">
            <xsl:copy-of select="text()"/>
          </xsl:attribute>
        </translation>
      </xsl:when>
      <xsl:otherwise>
        <translation value="{@template:i18n}"></translation>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:apply-templates select="@*|node()"/>
  </xsl:template>



  <!-- Handle attributes containing translation functions. -->

  <xsl:template match="@*[contains(string(), 'template:i18n')]">
    <xsl:variable name="after-parameter">template:i18n('</xsl:variable>
    <xsl:variable name="before-parameter">')</xsl:variable>
    <xsl:variable name="after" select="substring-after(string(), $after-parameter)"/>
    <xsl:variable name="fragment" select="substring-before($after, $before-parameter)"/>
    <translation value="{$fragment}"></translation>
  </xsl:template>



  <!-- Traverse unknown nodes. -->

  <xsl:template match="@*|node()">
    <xsl:apply-templates select="@*|node()"/>
  </xsl:template>

</xsl:stylesheet>
